// PicGenial.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "PicGenial.h"


#define DISTANCESROUES	2
#define CENTERY 160
#define CENTERX	160
#define SEMI_ARRAY 60.0	
#define PI 3.145926
#define ZOOMARRAY 40
#define LARGEUR 12
#define NOZOOM 2.4
#define WITHZOOM 6.0


// Global Variables:
HINSTANCE	hInst;		// current instance
WNDPROC wpOrigEditProc; 
HWND hWndMain;
HWND hWndStatus;
HWND hWndHelpAgent;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT APIENTRY	EditSubclassProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	HelpAgent(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

void ResetSimulation(void);

//PicGenial Global vars
int	EditMode;	//0 = non editing, 1 = editing left, 2 = editing right
PStep Steps[10][20];
int	oxPos;
int oyPos;
int	LStep;
int	RStep;
int BrakePointPos[10];
int ListSelPos;
int p;
RECT DistListRect;
RECT RobotClientRect;
RECT RobotClientRectMem;
RECT RobotClientBound;
RECT BrakePointRect;
RECT ListSelRect;
HWND hwndEdit;
char s[80];
char *Build = "28";
char *Version = "Beta 1.1"; 
char *History = "\nTraX is a Robot TraCKs Simulator\n\nTraX is an educational product\n\nSee Help Content for details";
char *MainTitle = "TraX Beta 1.1";
HBITMAP agentframes[4];
HBITMAP brake;
tPoints Traj;
char fname[260];
bool zoom;
POINT zoomPos;
bool Ended=false;

//Simulation Structure
typedef struct 
{
	float PosX,PosY;
	float Angle;
	int SimState;
	int PosInArray;
	int NumberOfStep;
	int ActStep;
	float AGpAD;
	float AGmAD;
	float AG;
	float AD;
} SimStruct;

SimStruct	SimData;


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
 	MSG msg;
	HACCEL hAccelTable;
	RECT StatusBarRect;

	// Initialize global strings
	MyRegisterClass(hInstance);
	
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Load accelerators
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_PICGENIAL);

	// Init status bar
	InitCommonControls();
	hWndStatus=CreateStatusWindow(WS_CHILD|WS_VISIBLE,"Welcome in TraX",hWndMain,ID_STATUS);
	
	// Set correct position
	GetWindowRect(hWndStatus,&StatusBarRect);
	SetWindowPos(hWndMain,NULL,0,0,(GetSystemMetrics(SM_CXSIZEFRAME)<<1)+418+18+30,323+GetSystemMetrics(SM_CYSIZEFRAME)+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYCAPTION)+(StatusBarRect.bottom-StatusBarRect.top),SWP_NOOWNERZORDER|SWP_NOMOVE);

	// Inititialisation global var
	SetRect(&DistListRect,29,0,130,321);
	SetRect(&RobotClientRect,149,0,469,321);
	SetRect(&BrakePointRect,132,0,148,321);
	SetRect(&ListSelRect,0,0,29,321);
	SetRect(&RobotClientRectMem,0,0,RobotClientRect.right-RobotClientRect.left,RobotClientRect.bottom-RobotClientRect.top);
	SetRect(&RobotClientBound,RobotClientRectMem.left+10,RobotClientRectMem.top+10,RobotClientRectMem.right-10,RobotClientRectMem.bottom-10);
	EditMode=0;
	for (int n=0;n<10;n++)
		BrakePointPos[n]=-1;
	ListSelPos=0;
	fname[0]='\0';
	zoom=false;

	// Load Agent Frames & BrakePoint bitmap
	agentframes[0]=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_NORMAL));
	agentframes[1]=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_ZOOM));
	agentframes[2]=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_CRASH));
	agentframes[3]=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_STOP));
	brake=LoadBitmap(hInst,MAKEINTRESOURCE(IDB_BRAKE));

	// Init Help Agent Window
	hWndHelpAgent=CreateDialog(hInst,(LPCSTR)IDD_HELPAGENT,hWndMain,(DLGPROC)HelpAgent);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_PICGENIAL);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_PICGENIAL;
	wcex.lpszClassName	= "PicGenial";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable

   hWndMain = CreateWindow("PicGenial", MainTitle,WS_OVERLAPPED| WS_CAPTION| WS_SYSMENU| WS_BORDER|WS_MINIMIZEBOX,
      20, 20,425, 365, NULL, NULL, hInstance, NULL);

   if (!hWndMain)
   {
      return FALSE;
   }

   ShowWindow(hWndMain, nCmdShow);
   UpdateWindow(hWndMain);

   return TRUE;
}



// _______________________________________
// 
// Transform absolute to screen coordinate
// _______________________________________

inline bool ToScreen(float x, float y, float scale, float bx, float by, POINT *pt)
{
	pt->x=(int)((x-bx)*scale)+((RobotClientRectMem.left+RobotClientRectMem.right)>>1);
	pt->y=(int)((y-by)*scale)+((RobotClientRectMem.top+RobotClientRectMem.bottom)>>1);
	if (PtInRect(&RobotClientBound,*pt))
		return true;
	else
		return false;
}


// ________________
// 
// Clear Point List
// ________________

void DeleteTraces(void)
{
	for (int n=0;n<MAXPTTRAJ;n++)
	{
		Traj.Px[n]=0;
		Traj.Py[n]=0;
		Traj.Pdir[n]=0;
	}
}

// _________________________
// 
// Add a Point to Point List
// _________________________

void AddAPoint(float x, float y,float dir)
{
//	p++;
//	if (p>5)
//	{
		p=0;
		if (Traj.act>=MAXPTTRAJ)
			Traj.act=0;
		Traj.Px[Traj.act]=x;
		Traj.Py[Traj.act]=y;
		Traj.Pdir[Traj.act]=dir;
		Traj.act++;
//	}
}


// __________________
// 
// Display Point List
// __________________

void DisplayPoints(HDC hdc,bool zoom,float x1,float y1, float x2,float y2)
{
	float x,y,dir;
	int n;
	POINT aff;
	HPEN hpg,hpd;

	// Get Colour
	hpg=CreatePen(PS_SOLID,0,RGB(0,0,255));
	hpd=CreatePen(PS_SOLID,0,RGB(0,255,00));

	for (n=0;n<MAXPTTRAJ;n++)
	{
		x=Traj.Px[n];
		y=Traj.Py[n];
		dir=Traj.Pdir[n];
		if (((x!=0.0f) || (y!=0.0f)) && (x>x1) && (x<x2) && (y>y1) && (y<y2))
		{
			if (zoom)
			{
				if (ToScreen(x,y,(float)WITHZOOM,(x1+x2)/2,(y1+y2)/2,&aff))
				{
					SelectObject(hdc,hpg);
					Rectangle(hdc,(int)(aff.x-1-sin(dir)*LARGEUR),(int)(aff.y-1+cos(dir)*LARGEUR),(int)(aff.x+1-sin(dir)*LARGEUR),(int)(aff.y+1+cos(dir)*LARGEUR));
					SelectObject(hdc,hpd);
					Rectangle(hdc,(int)(aff.x-1+sin(dir)*LARGEUR),(int)(aff.y-1-cos(dir)*LARGEUR),(int)(aff.x+1+sin(dir)*LARGEUR),(int)(aff.y+1-cos(dir)*LARGEUR));
				}
			}
			else
				if (ToScreen(x,y,(float)NOZOOM,0,0,&aff))
					SetPixel(hdc,aff.x,aff.y,0x000000FF);
		}
	}
	SelectObject(hdc,GetStockObject(BLACK_PEN));
	DeleteObject(hpg);
	DeleteObject(hpd);
}


// ____________________
//
// Reset the Simulation
// ____________________

void ResetSimulation(void)
{
	SimData.PosX=0.0;
	SimData.PosY=0.0;
	SimData.Angle=0.0;
	SimData.PosInArray=0;
	SimData.AG=(float)(((float)Steps[ListSelPos][0].LeftSpeed)/3.90);
	SimData.AD=(float)(((float)Steps[ListSelPos][0].RightSpeed)/3.90);
	SimData.AGpAD=SimData.AG+SimData.AD;
	SimData.AGmAD=SimData.AG-SimData.AD;
	SimData.NumberOfStep=abs((int)SimData.AD)+abs((int)SimData.AG);
	SimData.ActStep=0;
	sprintf(s,"Robot Position :  x=%.3f, y=%.3f",SimData.PosX,SimData.PosY);
	SetWindowText(hWndStatus,s);
	InvalidateRect(hWndMain,&DistListRect,FALSE);
	p=4;
}


// ___________________
//
// Stop the simulation
// ___________________

void StopSimulation(void)
{
	SimData.SimState=0;
	KillTimer(hWndMain,1);
	SendDlgItemMessage(hWndHelpAgent,IDC_IMG,STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM) (HANDLE) agentframes[3]);
}


// ____________________
//
// Start the simulation
// ____________________

void StartSimulation(void)
{
	if (SimData.SimState==0)
		SetTimer(hWndMain,1,30,NULL);
	SimData.SimState=1;
}


// _______________________
//
// Do a step of simulation
// _______________________

void DoSimulationStep(void)
{
	if (SimData.ActStep<SimData.NumberOfStep)
	{
		bool collision;

		SimData.PosX+=(float)((SimData.AGpAD/(2*SimData.NumberOfStep*0.957))*cos(SimData.Angle));
		SimData.PosY+=(float)((SimData.AGpAD/(2*SimData.NumberOfStep*0.957))*sin(SimData.Angle));
		SimData.Angle+=(float)atan(SimData.AGmAD/((2*SimData.NumberOfStep*0.957)*(float)DISTANCESROUES));
		SimData.ActStep++;

		// Simple Edge detection
		collision=FALSE;
		if (SimData.PosX>SEMI_ARRAY)
		{
			SimData.PosX=SEMI_ARRAY;
			collision=TRUE;
		}
		else if (SimData.PosX<-SEMI_ARRAY)
		{
			SimData.PosX=-SEMI_ARRAY;
			collision=TRUE;
		}
		
		if (SimData.PosY>SEMI_ARRAY)
		{
			SimData.PosY=SEMI_ARRAY;
			collision=TRUE;
		}
		else if (SimData.PosY<-SEMI_ARRAY)
		{
			SimData.PosY=-SEMI_ARRAY;
			collision=TRUE;
		}

		if (collision==FALSE)
		{
			sprintf(s,"Robot Position :  x=%.3f, y=%.3f",SimData.PosX,SimData.PosY);
			if (zoom)
				SendDlgItemMessage(hWndHelpAgent,IDC_IMG,STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM) (HANDLE) agentframes[1]);
			else
				SendDlgItemMessage(hWndHelpAgent,IDC_IMG,STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM) (HANDLE) agentframes[0]);
		}
		else
		{
			sprintf(s,"Robot Position :  x=%.3f, y=%.3f    WARNING : COLLISION",SimData.PosX,SimData.PosY);
			SendDlgItemMessage(hWndHelpAgent,IDC_IMG,STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM) (HANDLE) agentframes[2]);
		}
		SetWindowText(hWndStatus,s);
	}
	else
	{
		if ((SimData.PosInArray<19) && (SimData.PosInArray!=BrakePointPos[ListSelPos]))
		{
			SimData.PosInArray++;
			SimData.AG=(float)(((float)Steps[ListSelPos][SimData.PosInArray].LeftSpeed)/3.90);
			SimData.AD=(float)(((float)Steps[ListSelPos][SimData.PosInArray].RightSpeed)/3.90);
			SimData.AGpAD=SimData.AG+SimData.AD;
			SimData.AGmAD=SimData.AG-SimData.AD;
			SimData.NumberOfStep=abs((int)SimData.AD)+abs((int)SimData.AG);
			SimData.ActStep=0;
			InvalidateRect(hWndMain,&DistListRect,FALSE);
		}
		else
		{
			//ResetSimulation();
			if (SimData.PosInArray>=19)
				Ended=true;
			StopSimulation();
		}
	}
}


// ______________________
//
// Draw the virtual robot
// ______________________

void DrawSimulatedRobot(HDC hdc,int x, int y, float a, float s)
{
	MoveToEx(hdc,(int)(x+cos(a+(PI/2.0+PI/3.0))*s),(int)(y+sin(a+(PI/2.0+PI/3.0))*s),NULL);
	LineTo(hdc,(int)(x+cos(a+(PI/2.0-PI/3.0))*s),(int)(y+sin(a+(PI/2.0-PI/3.0))*s));
	LineTo(hdc,(int)(x+cos(a+(PI/2.0-PI+PI/3.0))*s),(int)(y+sin(a+(PI/2.0-PI+PI/3.0))*s));
	LineTo(hdc,(int)(x+cos(a+(PI/2.0-PI-PI/3.0))*s),(int)(y+sin(a+(PI/2.0-PI-PI/3.0))*s));
	LineTo(hdc,(int)(x+cos(a+(PI/2.0+PI/3.0))*s),(int)(y+sin(a+(PI/2.0+PI/3.0))*s));

	SetPixel(hdc,(int)(x+cos(a+(PI/2.0-PI/3.0))*s*0.6),(int)(y+sin(a+(PI/2.0-PI/3.0))*s*0.6),0x000000FF);
	SetPixel(hdc,(int)(x+cos(a+(PI/2.0-PI+PI/3.0))*s*0.6),(int)(y+sin(a+(PI/2.0-PI+PI/3.0))*s*0.6),0x000000FF);
}


// _______________________
//
// Redraw the main Windows
// _______________________

void RedrawMyWindow(HWND hWnd)
{
	HDC hdc;
	PAINTSTRUCT ps;
	char StepS[10];
	RECT r;
	
	GetUpdateRect(hWnd,&r,FALSE);
	hdc = BeginPaint(hWnd, &ps);
	SetBkMode(hdc, TRANSPARENT);

	if (IntersectRect(NULL,&r,&RobotClientRect)==0)
	{
		HDC	memdc;
		HPEN hpb,hop;
		HBITMAP hbm, hobm;
		HBRUSH hob;
		int w=RobotClientRectMem.bottom;
		int h=RobotClientRectMem.right;

		// Do double Buffering
		memdc=CreateCompatibleDC(hdc);
		hbm=CreateCompatibleBitmap(hdc,w,h);
		hobm=(struct HBITMAP__ *)SelectObject(memdc,hbm);
		hop=(struct HPEN__ *)SelectObject(memdc,GetStockObject(WHITE_PEN));
		hob=(struct HBRUSH__ *)SelectObject(memdc,GetStockObject(WHITE_BRUSH));

		// Erase Background
		SetMapMode(memdc,MM_TEXT);
		Rectangle(memdc,0,0,w,h);
		
		// Add the point to Point List
		AddAPoint(SimData.PosX,SimData.PosY,SimData.Angle);

		// Draw the blue square
		hpb=CreatePen(PS_SOLID,0,RGB(0,0,255));
		SelectObject(memdc,hpb);
		SelectObject(memdc,GetStockObject(NULL_BRUSH));
		Rectangle(memdc,10,10,w-10,h-10);

		if (zoom)
		{
			POINT pt;
			float px,py;
			//NONCLEAN
			//Calculate Point from zoom
			px=(float)((zoomPos.x-(RobotClientRectMem.right>>1))/NOZOOM);
			py=(float)((zoomPos.y-(RobotClientRectMem.bottom>>1))/NOZOOM);

			// Draw Points
			//DisplayPoints(memdc,true,SimData.PosX-ZOOMARRAY,SimData.PosY-ZOOMARRAY,SimData.PosX+ZOOMARRAY,SimData.PosY+ZOOMARRAY);
			DisplayPoints(memdc,true,px-ZOOMARRAY,py-ZOOMARRAY,px+ZOOMARRAY,py+ZOOMARRAY);

			// Draw Robot
			// old version, on robot
			//ToScreen(SimData.PosX,SimData.PosY,(float)WITHZOOM,SimData.PosX,SimData.PosY,&pt);
			ToScreen(SimData.PosX,SimData.PosY,(float)WITHZOOM,px,py,&pt);
			// new version, everywhere
			SelectObject(memdc,GetStockObject(BLACK_PEN));
			DrawSimulatedRobot(memdc,pt.x,pt.y,SimData.Angle,27);
		}
		else
		{
			POINT pt;

			// Draw Points
			DisplayPoints(memdc,false,-SEMI_ARRAY-1,-SEMI_ARRAY-1,SEMI_ARRAY+1,SEMI_ARRAY+1);

			// Draw Robot
			ToScreen(SimData.PosX,SimData.PosY,(float)NOZOOM,0.0,0.0,&pt);
			SelectObject(memdc,GetStockObject(BLACK_PEN));
			DrawSimulatedRobot(memdc,pt.x,pt.y,SimData.Angle,10);
		}
		
		// Blit
		BitBlt(hdc,RobotClientRect.left,0,w,h,memdc,0,0,SRCCOPY);

		// Free memory
		SelectObject(memdc,hobm);
		SelectObject(memdc,hop);
		SelectObject(memdc,hob);
		DeleteObject(hpb);
		DeleteDC(memdc);
		DeleteObject(hbm);
	}

	if (IntersectRect(NULL,&r,&DistListRect)==0)
	{
		HPEN hop;
		HFONT hof;
		HBRUSH hob,hby;

		// Select Pen and font
		hof=(struct HFONT__ *)SelectObject(hdc,GetStockObject(ANSI_VAR_FONT));
		hop=(struct HPEN__ *)SelectObject(hdc,GetStockObject(BLACK_PEN));;

		for (int n=0;n<20;n++)
		{
			// Draw array cells
			if (n==SimData.PosInArray)
			{
				hby=CreateSolidBrush(RGB(0,255,255));
				hob=(struct HBRUSH__ *)SelectObject(hdc,hby);
				Rectangle(hdc,DistListRect.left,(n+1)<<4,DistListRect.left+101,((n+1)<<4)+17);
				SelectObject(hdc,hob);
				DeleteObject(hby);				
			}
			else
			{
				hob=(struct HBRUSH__ *)SelectObject(hdc,GetStockObject(WHITE_BRUSH));
				Rectangle(hdc,DistListRect.left,(n+1)<<4,DistListRect.left+101,((n+1)<<4)+17);
				SelectObject(hdc,hob);
			}
		}

		// Draw title cell
		Rectangle(hdc,DistListRect.left,0,DistListRect.left+101,17);
	
		// Draw titles
		TextOut(hdc,DistListRect.left+2,2,"Dep. G",6);
		TextOut(hdc,DistListRect.left+52,2,"Dep. D",6);

		// Draw text
		for (n=0;n<19;n++)
		{
			itoa(Steps[ListSelPos][n].LeftSpeed,StepS,10);
			TextOut(hdc,DistListRect.left+3,(n<<4)+17,StepS,strlen(StepS));
			itoa(Steps[ListSelPos][n].RightSpeed,StepS,10);
			TextOut(hdc,DistListRect.left+53,(n<<4)+17,StepS,strlen(StepS));
		}

		// Draw vertical line
		MoveToEx(hdc,DistListRect.left+50,0,NULL);
		LineTo(hdc,DistListRect.left+50,320);

		// restaur color
		SelectObject(hdc,hof);
		SelectObject(hdc,hop);
	}

	if (IntersectRect(NULL,&r,&BrakePointRect)==0)
	{
		Rectangle(hdc,BrakePointRect.left,BrakePointRect.top,BrakePointRect.right,BrakePointRect.bottom);
		if (BrakePointPos[ListSelPos]!=-1)
		{
			HDC	memdc;

			// Draw brakepoint
			memdc=CreateCompatibleDC(hdc);
			SelectObject(memdc,brake);
			BitBlt(hdc,BrakePointRect.left+1,(BrakePointPos[ListSelPos]<<4)+17,14,14,memdc,0,0,SRCCOPY);
			DeleteDC(memdc);
		}
	}

	if (IntersectRect(NULL,&r,&ListSelRect)==0)
	{
		HBRUSH hob;
		char s[16];

		hob=(struct HBRUSH__ *)SelectObject(hdc,GetStockObject(NULL_BRUSH));
		for (int n=0;n<320;n+=32)
		{
			sprintf(s,"%d",(n>>5));
			if ((n>>5)==ListSelPos)
			{
				Rectangle(hdc,2,n+1,30,n+32);
				TextOut(hdc,9,n+8,s,strlen(s));
			}
			else
			{
				Rectangle(hdc,12,n+1,30,n+32);
				TextOut(hdc,17,n+8,s,strlen(s));
			}
		}
		SelectObject(hdc,hob);
	}

	EndPaint(hWnd, &ps);
}


// ____________________
//
// Terminate Text Input
// ____________________

void CloseInArrayEdit(int xPos,int yPos)
{
	char	StepS[10];

	// Save the content of the actual Edit Box
	GetDlgItemText(hWndMain,ID_EDITCHILD,StepS,10);
	if (EditMode==1)
		Steps[ListSelPos][((yPos-16)>>4)].LeftSpeed=atoi(StepS);
	else
		Steps[ListSelPos][((yPos-16)>>4)].RightSpeed=atoi(StepS);
	ResetSimulation();

	// Remove the subclass from the edit control. 
    SetWindowLong(hwndEdit, GWL_WNDPROC,(LONG) wpOrigEditProc); 
            
	// Destruction of right Edit Box
	DestroyWindow(hwndEdit);
	EditMode=0;
}


// ________________
//
// Begin Text Input
// ________________

void CreateInArrayEdit(int xPos,int yPos)
{
	int col;
	char StepS[10];

	if (xPos<50+DistListRect.left)
	{
		col=0;
		itoa(Steps[ListSelPos][((yPos-16)>>4)].LeftSpeed,StepS,10);
	}
	else
	{
		col=1;
		itoa(Steps[ListSelPos][((yPos-16)>>4)].RightSpeed,StepS,10);
	}

	// Creation of Left Edit Box
	hwndEdit = CreateWindowEx( WS_EX_STATICEDGE,"EDIT",NULL,
		WS_CHILD | WS_VISIBLE | ES_LEFT, 
		col*50+1+DistListRect.left, ((yPos >>4)<<4)+1, 49, 15,hWndMain,
		(HMENU) ID_EDITCHILD, 
		(HINSTANCE) GetWindowLong(hWndMain, GWL_HINSTANCE), NULL);
	SendMessage(hwndEdit,WM_SETFONT,(WPARAM) (HFONT__ *)GetStockObject(ANSI_VAR_FONT),MAKELPARAM(TRUE, 0));    

	// Subclass the edit control. 
    wpOrigEditProc = (WNDPROC) SetWindowLong(hwndEdit, GWL_WNDPROC, (LONG) EditSubclassProc); 
            

	// Setting of actual value
	SetDlgItemText(hWndMain,ID_EDITCHILD,StepS);
	SetFocus(hwndEdit);
	SendMessage(hwndEdit,EM_SETSEL ,(WPARAM) (INT) 0,(LPARAM) (INT) -1);    

	EditMode=(col+1);
}


//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
					DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
					break;
				case IDM_HELPCONTENT:
					HtmlHelp(NULL, "TraX.chm", HH_DISPLAY_TOPIC, 0);
					break;
				case IDM_EXIT:
					DestroyWindow(hWnd);
					break;
				case ID_OPEN:
					{
						OPENFILENAME ofn;
						char szFile[260];

						szFile[0]='\0';

						// Initialize OPENFILENAME struct for the Open dialog box
						ZeroMemory(&ofn, sizeof(OPENFILENAME));
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hWnd;
						ofn.lpstrFile = szFile;
						ofn.nMaxFile = sizeof(szFile);
						ofn.lpstrFilter = "TraX\0*.TrX\0All\0*.*\0";
						ofn.nFilterIndex = 1;
						ofn.lpstrFileTitle = NULL;
						ofn.nMaxFileTitle = 0;
						ofn.lpstrInitialDir = NULL;
						ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;

						// Display the Open dialog box. 
						if (GetOpenFileName(&ofn)==TRUE)
						{
							FILE *fp;

							strcpy(fname,ofn.lpstrFile);
							
							fp=fopen(ofn.lpstrFile,"rb");
							fread(Steps,10*20*sizeof(PStep),1,fp);
							fclose(fp);
							ResetSimulation(); 
							InvalidateRect(hWnd,&DistListRect,FALSE);
						}
 
					}
					break;
				case ID_SAVEAS:
					{
						OPENFILENAME ofn;
						char szFile[260];

						szFile[0]='\0';

						// Initialize OPENFILENAME struct for the Save dialog box
						ZeroMemory(&ofn, sizeof(OPENFILENAME));
						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hWnd;
						ofn.lpstrFile = szFile;
						ofn.nMaxFile = sizeof(szFile);
						ofn.lpstrFilter = "TraX\0*.TrX\0All\0*.*\0";
						ofn.nFilterIndex = 1;
						ofn.lpstrFileTitle = NULL;
						ofn.nMaxFileTitle = 0;
						ofn.lpstrInitialDir = NULL;
						ofn.lpstrDefExt = ".PPS";
						ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;

						// Display the Save dialog box. 
						if (GetSaveFileName(&ofn)==TRUE)
						{
							FILE *fp;
							strcpy(fname,ofn.lpstrFile);
							
							fp=fopen(ofn.lpstrFile,"wb");
							fwrite(Steps,10*20*sizeof(PStep),1,fp);
							fclose(fp);
						}
 					}
					break;
				case ID_SAVE:
					{
						if (fname[0]=='\0')
						{
							OPENFILENAME ofn;
							char szFile[260];

							szFile[0]='\0';

							// Initialize OPENFILENAME struct for the Open dialog box
							ZeroMemory(&ofn, sizeof(OPENFILENAME));
							ofn.lStructSize = sizeof(OPENFILENAME);
							ofn.hwndOwner = hWnd;
							ofn.lpstrFile = szFile;
							ofn.nMaxFile = sizeof(szFile);
							ofn.lpstrFilter = "TraX\0*.TrX\0All\0*.*\0";
							ofn.nFilterIndex = 1;
							ofn.lpstrFileTitle = NULL;
							ofn.nMaxFileTitle = 0;
							ofn.lpstrInitialDir = NULL;
							ofn.lpstrDefExt = ".PPS";
							ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;

							// Display the Save dialog box. 
							if (GetSaveFileName(&ofn)==TRUE)
							{
								FILE *fp;
								strcpy(fname,ofn.lpstrFile);
								
								fp=fopen(ofn.lpstrFile,"wb");
								fwrite(Steps,10*20*sizeof(PStep),1,fp);
								fclose(fp);
							}
						}
						else
						{
							FILE *fp;
							
							fp=fopen(fname,"wb");
							fwrite(Steps,10*20*sizeof(PStep),1,fp);
							fclose(fp);
						}
						
					}
					break;
				case ID_STARTSIMULATION:
					{
						if (Ended)
						{
							ResetSimulation();
							Ended=false;
						}
						if (EditMode!=0)
							CloseInArrayEdit(oxPos,oyPos);
						StartSimulation();
					}
					break;
				case ID_STOPSIMULAION:
					StopSimulation();
					break;
				case ID_RESETSIMULATION:
					{
						ResetSimulation();
						InvalidateRect(hWnd,&RobotClientRect,FALSE);
					}
					break;
				case ID_EDITCHILD:
					switch (wmEvent)
					{
						case EN_KILLFOCUS:
							CloseInArrayEdit(oxPos,oyPos);
							break;
					}
					break;
				case ID_VIEWHELPAGENT:
					if (IsWindowVisible(hWndHelpAgent))
					{
						ShowWindow(hWndHelpAgent,SW_HIDE);
						CheckMenuItem(GetMenu(hWndMain),ID_VIEWHELPAGENT,MF_UNCHECKED);
					}
					else
					{
						ShowWindow(hWndHelpAgent,SW_SHOW);
						CheckMenuItem(GetMenu(hWndMain),ID_VIEWHELPAGENT,MF_CHECKED);						
					}
					break;
				case ID_ZOOMONROBOT:
					{
						if (zoom)
						{
							zoom=false;
							CheckMenuItem(GetMenu(hWndMain),ID_ZOOMONROBOT,MF_UNCHECKED);
						}
						else
						{
							zoom=true;
							CheckMenuItem(GetMenu(hWndMain),ID_ZOOMONROBOT,MF_CHECKED);
						}
						InvalidateRect(hWnd,&RobotClientRect,FALSE);
					}
				case ID_DELETETRACES:
					{
						DeleteTraces();
						InvalidateRect(hWndMain,&RobotClientRect,FALSE);
					}
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_RBUTTONDOWN:
			{
				zoomPos.x=LOWORD(lParam);  // horizontal position of cursor 
				zoomPos.y=HIWORD(lParam); // vertical position of cursor
				if (PtInRect(&RobotClientRect,zoomPos))
				{
					zoom=!zoom;
					zoomPos.x-=RobotClientRect.left;
					InvalidateRect(hWnd,&RobotClientRect,FALSE);
				}
			}
			break;
		case WM_LBUTTONDOWN:
			{
				POINT Pos;
				Pos.x = LOWORD(lParam);  // horizontal position of cursor 
				Pos.y = HIWORD(lParam);  // vertical position of cursor
				
				if (PtInRect(&DistListRect,Pos))
				{
					if ((Pos.y>16) && (Pos.y<320))
					{
						if (EditMode!=0)
							CloseInArrayEdit(oxPos,oyPos);
						oxPos=Pos.x;
						oyPos=Pos.y;
						CreateInArrayEdit(Pos.x,Pos.y);
					}
				}
				else if (PtInRect(&BrakePointRect,Pos))
				{
					if ((Pos.y<16) || (((Pos.y-16)>>4)==BrakePointPos[ListSelPos]))
						BrakePointPos[ListSelPos]=-1;
					else
						BrakePointPos[ListSelPos]=(Pos.y-16)>>4;
					InvalidateRect(hWnd,&BrakePointRect,FALSE);
				}
				else if (PtInRect(&ListSelRect,Pos))
				{
					ListSelPos=(Pos.y>>5);
					InvalidateRect(hWnd,&ListSelRect,TRUE);
					InvalidateRect(hWnd,&DistListRect,FALSE);
					InvalidateRect(hWnd,&BrakePointRect,FALSE);
					ResetSimulation();
				}
				else
				{
					if (EditMode!=0)
						CloseInArrayEdit(oxPos,oyPos);
					if (Ended)
					{
						ResetSimulation();
						Ended=false;
					}
					if (SimData.SimState==0)
						StartSimulation();
					else
						StopSimulation();					
				}	
			}
			break;
		case WM_PAINT:
			RedrawMyWindow(hWnd);
			break;
		case WM_DESTROY:
			{
			DeleteObject(agentframes[0]);
			DeleteObject(agentframes[1]);
			DeleteObject(agentframes[2]);
			DeleteObject(agentframes[3]);
			DeleteObject(brake);
			PostQuitMessage(0);
			}
			break;
		case WM_TIMER:
			if (SimData.SimState==1)
			{
				DoSimulationStep();
				InvalidateRect(hWnd,&RobotClientRect,FALSE);
			}
			break;
		case WM_SIZE:
			SendMessage(hWndStatus,WM_SIZE,wParam,lParam);
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			{
			char tmp[255];
			strcpy(tmp,MainTitle);
			strcat(tmp,"\nVERSION : ");
			strcat(tmp,Version);
			strcat(tmp," - BUILD : ");
			strcat(tmp,Build);
			strcat(tmp,"\n");
			strcat(tmp,History);
			SetDlgItemText(hDlg,IDC_TEXT,tmp);
			}
			return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
				EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
	}
    return FALSE;
}


// Subclass procedure for Edit, handles all specials mesages for the EditBOX
LRESULT APIENTRY EditSubclassProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{ 
	switch (uMsg)
	{
		case WM_KEYDOWN :
			{
				switch (wParam) 
				{ 
					case VK_RETURN:
						CloseInArrayEdit(oxPos,oyPos);
						break;
 
					case VK_UP: 
						{
							if (oyPos>32)
							{
								CloseInArrayEdit(oxPos,oyPos);
								oyPos-=16;
								CreateInArrayEdit(oxPos,oyPos);
							} 
						}
						break; 
 
					case VK_DOWN:
						{
							if (oyPos<320-16)
							{
								CloseInArrayEdit(oxPos,oyPos);
								oyPos+=16;
								CreateInArrayEdit(oxPos,oyPos);
							}
						}
						break;

					case VK_TAB:
						{
							if (EditMode==1)
							{
								CloseInArrayEdit(oxPos,oyPos);
								oxPos+=50;
								CreateInArrayEdit(oxPos,oyPos);
							}
							else
							{
								if (oyPos<320-16)
								{
									CloseInArrayEdit(oxPos,oyPos);
									oyPos+=16;
									oxPos-=50;
									CreateInArrayEdit(oxPos,oyPos);
								}
							}
						}
						break;
					
					/*case VK_F5:
						{
							CloseInArrayEdit(oxPos,oyPos);
							StartSimulation();
						}
						break;*/

					/*default:
						SendMessage(hWndMain,uMsg,wParam,lParam);
						break;*/
				}
			}
			break;
	}
    return CallWindowProc(wpOrigEditProc, hwnd, uMsg, wParam, lParam); 
} 


// ______________________________
//
// Message handler for Help Agent
// ______________________________

LRESULT CALLBACK HelpAgent(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			return TRUE;

		case WM_COMMAND:
			return TRUE;

		case WM_CLOSE:
			ShowWindow(hWndHelpAgent,SW_HIDE);
			CheckMenuItem(GetMenu(hWndMain),ID_VIEWHELPAGENT,MF_UNCHECKED);
			return TRUE;
	}
    return FALSE;
}